/*
 * Copyright 2000 by Docuverse
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Docuverse ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you
 * entered into with Docuverse.
 */

package com.docuverse.min;

final class NameTable
{
	Name[]	hashtable = new Name[541];

		final Name
	getName(char[] value, int offset, int length)
	{
		int		index = 0;
		Name	entry;
		int		end = offset + length;

			// hashing to get index
		for (int i = offset; i < end; i++)
			index = index * 31 + value[i];

		index &= 0x7fffffff;
		index %= hashtable.length;

			// return entry if one's there ...
		for (entry = hashtable[index]; entry != null; entry = entry.next)
			if (entry.matches(value, offset, length))
				return entry;

			// else create new one
		entry = new Name ();
		entry.next = hashtable[index];
		entry.value = new String(entry.array = value,
			entry.start = offset, entry.count = length);
		hashtable[index] = entry;
		return entry;
	}
}
