/*
 * Copyright 2000 by Docuverse
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Docuverse ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you
 * entered into with Docuverse.
 */

package com.docuverse.min;

final class Name
{
	Name		next;
	String		value;
	char[]		array;
	int			start;
	int			count;

		final boolean
	matches (char[] value, int offset, int length)
	{
		if (length != count)
			return false;
		
		char[] a = array;
		int i = offset + length;
		int j = start + length;
		while (i > offset)
			if (value[--i] != a[--j])
				return false;
	
		return true;
	}
}
